package counter;

import java.util.concurrent.locks.ReentrantLock;

public class ThreadSafe2Counter implements Counter {
    private final ReentrantLock lock;
    private long counter;
    public ThreadSafe2Counter() {
        lock = new ReentrantLock();
    }

    @Override
    public void increment() {
        lock.lock();
        try {
            counter++;
        } finally {
            lock.unlock();
        }
    }

    @Override
    public long getValue() {
        lock.lock();
        try {
            return counter;
        } finally {
            lock.unlock();
        }
    }
}
