package pc;

import org.junit.Test;

public class ProducerConsumerTest {
    @Test
    public void runProducerConsumerWithJavaUtilConcurrent() throws Exception {
        runWith(new JavaUtilConcurrentProducerConsumerQueue<>());
    }

    @Test
    public void runProducerConsumerWithMyQueue() throws Exception {
        runWith(new MyProducerConsumerQueue<>());
    }

    private void runWith(ProducerConsumerQueue<Integer> queue) throws InterruptedException {
        Consumer<Integer> c = new Consumer<>(queue);
        Producer p = new Producer(c);
        c.start();
        p.start();
        p.join();
        c.join();
    }
}
